#include <windows.h>
#include <commctrl.h> 

#include "resource.h" 

#define INCTIMERID1 1

int progress=50;
int zeit;

LRESULT CALLBACK WindProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL CALLBACK HelpProc(HWND hwnd,UINT Message,WPARAM wParam,LPARAM lParam);

HINSTANCE hInstance;
HDC hdc;

//---------------------------------------------------------------------------
//				HAUPTFENSTER
//---------------------------------------------------------------------------
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	static TCHAR szAppName[] = TEXT ("DIALOG01") ;

    HWND        hwnd ;	//HWND fr Hauptfenster
	MSG         msg ; // das message handling heist msg
    WNDCLASS    windclass ; //das Hauptfenster gehrt zu windclass - Klasse

    windclass.style         = CS_HREDRAW | CS_VREDRAW;
    windclass.lpfnWndProc   = WindProc ; 
    windclass.cbClsExtra    = 0 ;
    windclass.cbWndExtra    = DLGWINDOWEXTRA ;    
    windclass.hInstance     = hInstance ;
    windclass.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON));
    windclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
    windclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1) ;
    windclass.lpszMenuName  = "IDM_MENU";
    windclass.lpszClassName = szAppName ;

    if (!RegisterClass (&windclass))
    {
        return 0 ;
    }

    hwnd = CreateDialog (hInstance, szAppName, 0, NULL) ; 

	InitCommonControls();    
    ShowWindow (hwnd, iCmdShow);
	UpdateWindow(hwnd);
    PostMessage(hwnd, WM_COMMAND, IDC_INIT,0); //rufe diese funktion auf -> init()   
    while (GetMessage (&msg, NULL, 0, 0)) 
    {
        TranslateMessage (&msg) ;
        DispatchMessage (&msg) ;
    }
    return msg.wParam ;
}

void Init ( HWND hwnd)
{
	SendMessage(GetDlgItem(hwnd,IDC_PROGRESS), PBM_SETPOS,(WPARAM)progress,0);
}


void CALLBACK IncTimer1 (HWND hwnd, UINT iMsg, UINT iTimer, DWORD dwTime)
{
	progress++;

	if(progress<100)
	{
		Init(hwnd);
	}
	
	if(progress>=100)
	{
		progress=0;
		Init(hwnd);
	}
}

//Abfragen zum im Hauptfenster befindlichen Knpfe + Buttons etc. ...
LRESULT CALLBACK WindProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
    {
		case WM_CREATE:
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
		break;

		case WM_COMMAND:
        {
			switch( LOWORD( wParam ) )
            {
                case IDC_INIT:
                {
					Init(hwnd);					
			    }
                break;

			    case IDC_ZURUECK:
				{
					progress=progress-10;
					if(progress<0)
						progress=0;
					else
						Init(hwnd);
				}
				break;

				case IDC_WEITER:
				{
					progress=progress+10;
					if(progress>100)
						progress=100;
					else
						Init(hwnd);
				}
				break;

				case IDC_BEENDEN:
					PostQuitMessage(0);
				break;

				case IDC_AUTO:
				{
					BOOL bSuccess;
					zeit = GetDlgItemInt(hwnd, IDC_ZEIT, &bSuccess, FALSE);
					SetTimer(hwnd, INCTIMERID1, zeit, (TIMERPROC) IncTimer1);
				}
				break;

				case IDC_STOP:
					KillTimer(hwnd, INCTIMERID1);
				break;
   			}
        }
        return 0 ;
	}
    return DefWindowProc (hwnd, message, wParam, lParam) ;
}
